//
//  Clip.h
//  igroup
//

#import <Foundation/Foundation.h>

#import "Song.h"

@class Song; 

@interface Clip : NSObject {
	NSString *name;
	Song *parent;
	double start;
	double end;
	BOOL customIntervalIsSet;
}

@property double start, end; 
@property (nonatomic, retain) NSString *name; 
@property (nonatomic, retain) Song * parent; 

- (id)initWithSong:(Song *)parentSong;

- (id)initWithName:(NSString *)aName song:(Song *)parentSong start:(NSNumber *)startValue end:(NSNumber *)endValue; 

/** Clips are serialized in an array where the first value is the start time, the second value is the end time, and the final value is
 *  the name of the Song 
 */
+ (NSDictionary *)save;

+ (void)load:(NSDictionary *)serializedData;

@end
