//
//  Clip.m
//  igroup
//

#import "Clip.h"


@implementation Clip

@synthesize start, end; 
@synthesize parent, name; 

static NSMutableArray *clips;

- (id) init { 
	if ( self = [super init] ) 
	{ 
		name = [[NSString alloc] init];
		customIntervalIsSet = NO;
	} 
	return self; 
}

- (id)initWithSong:(Song *)parentSong {
	if (!(self = [self init])) return nil;
	
	parent = [parentSong retain];
	
	return self; 
}

- (id)initWithName:(NSString *)aName song:(Song *)parentSong start:(NSNumber *)startValue end:(NSNumber *)endValue {
	if (!(self = [self init])) return nil;
	
	start = [startValue doubleValue];
	end = [endValue doubleValue];
	parent = [parentSong retain];
	name = aName;
	
	return self;
}

#pragma mark Override start and end getters/setters.

- (double)start {
	return customIntervalIsSet ? start : 0.0;
}

- (double)end {
	return customIntervalIsSet? end : [[parent.songMediaItem valueForProperty:MPMediaItemPropertyPlaybackDuration] doubleValue];
}

- (void)setStart:(double)customStart {
	start = customStart;
	customIntervalIsSet = YES;
}

- (void)setEnd:(double)customEnd {
	end = customEnd;
	customIntervalIsSet = YES;
}

+ (NSDictionary *)save { 
	NSMutableDictionary *serializedData = [[NSMutableDictionary alloc] init];
	NSLog(@"Saving Clips");
	for (Clip *clip in clips) {
		NSMutableArray *object = [[NSMutableArray alloc] init]; 
		[object addObject:[NSNumber numberWithInteger:clip.start]]; 
		[object addObject:[NSNumber numberWithInteger:clip.end]]; 
		[object addObject:clip.parent.title]; 
		NSLog(@"clip name saved is %@", clip.name);
		[serializedData setObject:object forKey:clip.name];
		[object release]; 
	}
	
	return serializedData;
	
}

+ (void)load:(NSDictionary *)serializedData {
	Clip *clip;
	for (NSString *name in serializedData) {
		NSArray *clipValues = [serializedData objectForKey:name]; 
		clip = [[Clip alloc] initWithName:name song:[Song getSong:[clipValues objectAtIndex:2]] start:[clipValues objectAtIndex:0]
									  end:[clipValues objectAtIndex:1]]; 
		//[clipValues release]; 
		//[clip release];
	}
}
@end
