//
//  ClipEditSlider.h
//  igroup
//

#import <UIKit/UIKit.h>


@interface ClipEditSlider : UIControl {
	UIImageView *thumbLeft, *thumbRight;
	UIImageView *activeThumb;
	UIView *activeTrack, *trackBase;
	
	double trackMin, trackMax;	// left and right boundaries on the track
	double minimumX, maximumX;	// min and max horizontal values on the track
	double leftX, rightX;		// x values on the track
	
	double valueLeft, valueRight;
	double minimumValue, maximumValue;
}

@property (nonatomic, retain) IBOutlet UIImageView *thumbLeft, *thumbRight;
@property (nonatomic, retain) UIImageView *activeThumb;
@property (nonatomic, retain) IBOutlet UIView *activeTrack, *trackBase;
@property double valueLeft, valueRight;
@property double minimumValue, maximumValue;


- (void)setOriginX:(double)x ofThumb:(UIImageView *)thumb;

#pragma mark Helpers for updating UI

/** 
 * Update activeThumb's center horizontal coordinate
 * Pre-condition: x is within bounds of the slider.
 */
- (void)updateActiveThumbPosition:(double)centerX;

/** Updates the active part of the track. */
- (void)updateActiveTrack;

/** Returns YES if touching a thumb. */
- (BOOL)touch:(UITouch *)touch isThumb:(UIImageView *)thumb;

/** Return YES if activeThumb can be moved to the given center horizontal coordinate. */
- (BOOL)activeThumbPointIsValid:(double)centerX;

@end
