//
//  PlayEditViewController.h
//  igroup
//

#import <UIKit/UIKit.h>
#import <MediaPlayer/MediaPlayer.h>

#import "Song.h"
#import "Clip.h"

#import "ClipEditSliderViewController.h"
#import "ClipEditSlider.h"

@interface PlayEditViewController : UIViewController <UIAlertViewDelegate> {
	ClipEditSliderViewController *clipEditSliderViewController;
	ClipEditSlider *clipEditSlider;
	
	UINavigationItem *clipName;
	UILabel *songTitleLabel;
	UILabel *artistNameLabel;
	UILabel *clipStartTimeLabel, *clipEndTimeLabel;
	UILabel *clipCurrentTimeLabel, *clipTimeLeftLabel;
	UIBarButtonItem *repeatButton, *playButton, *saveButton;
	UIImageView *pointer;
	
	Clip *clip;
	MPMediaItem *songMediaItem;
	
	UITextField *textfield;
	
	NSTimer *playbackTimer;
	double trackMinX, trackMaxX;
}

@property (nonatomic, retain) ClipEditSliderViewController *clipEditSliderViewController;
@property (nonatomic, retain) ClipEditSlider *clipEditSlider;

@property (nonatomic, retain) IBOutlet UINavigationItem *clipName;
@property (nonatomic, retain) IBOutlet UILabel *songTitleLabel;
@property (nonatomic, retain) IBOutlet UILabel *artistNameLabel;
@property (nonatomic, retain) IBOutlet UILabel *clipStartTimeLabel, *clipEndTimeLabel;
@property (nonatomic, retain) IBOutlet UILabel *clipCurrentTimeLabel, *clipTimeLeftLabel;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *repeatButton, *playButton, *saveButton;
@property (nonatomic, retain) IBOutlet UIImageView *pointer;
@property (nonatomic, retain) Clip *clip;
@property (nonatomic, retain) MPMediaItem *songMediaItem;
@property (nonatomic, retain) UITextField *textfield;
@property (nonatomic, retain) NSTimer *playbackTimer;

- (IBAction)backToSongs:(id)sender;

- (IBAction)playButtonPressed:(id)sender;

- (IBAction)save:(id)sender;

- (IBAction)editName:(id)sender;  

- (IBAction)repeat:(id)sender;

- (void)play;

- (void)pause;

/** Adds a ClipEditSlider as a subview to this view controller's view. */
- (void)addClipEditSliderToView;

/** Event handler for when the clip edit slider's value is changed. */
- (void)clipEditSliderDidChange:(id)sender;

/** Updates the clip's starting time and ending time labels. */
- (void)updateClipTimeLabels;

/** Updates various playback states in the view. */
- (void)updatePlaybackState;

/** Moves pointer to the given time. */
- (void)movePointerToTime:(double)time;

@end
