//
//  Routine.m
//  igroup
//
//  Created by Vidya on 3/31/10.
//  Copyright 2010 iGroup. All rights reserved.
//

#import "Routine.h"

@implementation Routine

@synthesize clips, name;

static NSMutableArray *routines;

- (id) init { 
	if ( self = [super init] ) 
	{ 
		name = [[NSString alloc] init]; 
		clips = [[NSMutableArray alloc] init];
		[routines addObject:self];
	} 
	return self; 
}

- (id)initWithName:(NSString *)aName clips:(NSArray *)someClips {
	if (!(self = [self init])) return nil;
	
	self.name = aName;
	[clips addObjectsFromArray:someClips];
	
	return self;
}

+ (void)initialize {
    if (!routines) {
		routines = [[NSMutableArray alloc] init];
	}
}

+ (NSDictionary *)save {
	NSMutableDictionary *serializedData = [[NSMutableDictionary alloc] init];
	for (Routine *routine in routines) { 
		NSMutableArray *allClips = [[NSMutableArray alloc] init];
		for (Clip *clip in routine.clips) {
			//NSLog(@"%@", clip.name);
			[allClips addObject:clip]; 
		}
		
		[serializedData setObject:allClips forKey:routine.name];
	}
	return serializedData;
}

+ (void)load:(NSDictionary *)serializedData {
	Routine *routine;
	for (NSString *name in serializedData) {
		routine = [[Routine alloc] initWithName:name clips:[serializedData objectForKey:name]];
		//[routine release]; should be there? not there atm cuz it works.
	}
}

- (void) addClip:(Clip *)clip atPosition:(NSUInteger)num {
	[clips insertObject:clip atIndex:num]; 
}

- (Routine *) removeClipAtPosition:(NSUInteger)num {
	Routine *routine = [clips objectAtIndex:num]; 
	[clips removeObjectAtIndex:num];
	return routine; 
}

- (Clip *) getClipAtPosition:(NSUInteger)num {
	return [clips objectAtIndex:num]; 
}

+ (NSMutableArray *) getRoutines
{
	return routines; 
}
@end
