//
//  RoutineViewController.m
//  igroup
//

#import "RoutineViewController.h"
#import "PlayEditViewController.h"
#import "SongsViewController.h"; 
#import "PlayPauseRoutine.h" 
#import "Clip.h"

@implementation RoutineViewController

@synthesize tableView;
@synthesize myRoutine, textfield; 

- (id)initWithRoutine:(Routine *)thisRoutine
{
	if (!(self = [self initWithNibName:@"RoutineViewController" bundle:nil])) return nil;
	[self setMyRoutine:thisRoutine]; 
	
	/*if(myRoutine.clips.count == 0) { 
		Clip *clip1 = [[Clip alloc] initWithName:@"clip1" song:[[Song alloc] init] start:0 end:0]; 
		Clip *clip2 = [[Clip alloc] initWithName:@"clip2" song:[[Song alloc] init] start:0 end:0]; 
		Clip *clip3 = [[Clip alloc] initWithName:@"clip3" song:[[Song alloc] init] start:0 end:0]; 
		[myRoutine.clips addObject:clip1]; 
		[myRoutine.clips addObject:clip2]; 
		[myRoutine.clips addObject:clip3]; 
		[clip1 release]; 
		[clip2 release]; 
		[clip3 release]; 
	}*/
	NSLog(@"About to return clips");
	// Resize the table view
	return self; 
}
	
/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/


- (void)viewDidLoad {
    [super viewDidLoad];

    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    self.navigationItem.rightBarButtonItem = self.editButtonItem;
	self.navigationItem.title = myRoutine.name;
}



- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
}


- (void)viewDidAppear:(BOOL)animated {
	/**CGRect frame = self.tableView.frame;
	NSLog(@"frame x is %s", frame.origin.x);
	frame.origin.y = 50;
	frame.size.height = frame.size.height - frame.origin.y; 
	self.tableView.frame = frame; 
	if(self.tableView.frame.size.height != 100) { 
		NSLog(@"no change made"); 
	}
	PlayPauseRoutine *ppr = [[PlayPauseRoutine alloc] init]; 
	//frame = ppr.frame; 
	frame.origin.y = 0;
	frame.size.height = 50; 
	ppr.frame = frame; 
	ppr.backgroundColor = 0; 
	[[self view] addSubview:ppr]; **/
    [super viewDidAppear:animated];
}

/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)aTableView {
    return 1;
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)aTableView numberOfRowsInSection:(NSInteger)section {
    return [[myRoutine clips] count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)aTableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [aTableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
	NSInteger row = [indexPath row]; 
	NSLog(@"clip name is %@", [myRoutine getClipAtPosition:row]);
	cell.textLabel.text = [myRoutine getClipAtPosition:row].name; 
	
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	// PlayEditViewController *controller = [[PlayEditViewController alloc] initWithNibName:@"PlayEditViewController" bundle:nil];
	// [self presentModalViewController:controller animated:YES];
	// [controller release];
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


- (void)setEditing:(BOOL)editing animated:(BOOL)animate {
	tableView.editing = editing;

	[super setEditing:editing animated:animate]; 
}

// Override to support editing the table view.
- (void)tableView:(UITableView *)aTableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
		NSInteger row = [indexPath row]; 
		[myRoutine.clips removeObjectAtIndex:row]; 
        [aTableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
	}   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}

- (void)alertView:(UIAlertView *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
	self.navigationItem.title = myRoutine.name = textfield.text; 
}

			 
- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	[textfield resignFirstResponder];
	
    return YES;
}

- (IBAction)addClip { 
	SongsViewController *songViewController = [[SongsViewController alloc] init];
	[self.navigationController pushViewController:songViewController animated:YES]; 
	[songViewController release]; 
}

- (IBAction)rename {
	UIAlertView *myAlertView = [[UIAlertView alloc] initWithTitle:@"Enter Name of Routine" message:@"this gets covered" delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"Save", nil];
	textfield = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 45.0, 260.0, 25.0)];
	[textfield setBackgroundColor:[UIColor whiteColor]];
	textfield.returnKeyType = UIReturnKeyDefault;
	if (![myRoutine.name isEqualToString:@"Unnamed Routine"]) {
		textfield.text = myRoutine.name;
	}
	[myAlertView addSubview:textfield];
	CGAffineTransform myTransform = CGAffineTransformMakeTranslation(0.0, 130.0);
	[myAlertView setTransform:myTransform];
	[textfield becomeFirstResponder]; 
	[myAlertView show];
	[myAlertView release];
}

- (void) fetchClip:(Clip *)newClip { 
	[myRoutine addClip:newClip atPosition:[myRoutine.clips count]]; 
	[self.tableView reloadData]; 
}


// Override to support rearranging the table view.
- (void)tableView:(UITableView *)aTableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}

- (void)dealloc {
    [super dealloc];
}


@end

