//
//  RoutinesViewController.m
//  igroup
//
//  Created by weicool on 3/30/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "RoutinesViewController.h"
#import "RoutineViewController.h"
#import "Routine.h"

@implementation RoutinesViewController

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/


- (void)addRoutine
{
	Routine *newRoutine = [[Routine alloc] initWithName:@"Unnamed Routine" clips:nil]; 
	//NSUserDefaults *preferences = [NSUserDefaults standardUserDefaults];
	//NSDictionary *serializedData;
	
	//serializedData = [Routine save];
	//[preferences setObject:serializedData forKey:@"routines"];
	RoutineViewController *routineViewController = [[RoutineViewController alloc] initWithRoutine:newRoutine];
	[self.navigationController pushViewController:routineViewController animated:YES]; 
	[routineViewController release];
}

- (void)viewDidLoad {
    [super viewDidLoad];

    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    self.navigationItem.rightBarButtonItem = self.editButtonItem;
	self.navigationItem.title = @"Routines"; 
	UIBarButtonItem *newRoutine = [[UIBarButtonItem alloc] initWithTitle:@"Add Routine" style:UIBarButtonItemStylePlain target:self action:@selector(addRoutine)]; 	
	self.navigationItem.leftBarButtonItem = newRoutine;
	if([[Routine getRoutines] count] == 0) {
		NSLog(@"loading in data"); 
		[[Routine alloc] initWithName:@"Routine1" clips:[[NSArray alloc] init]]; 
		[[Routine alloc] initWithName:@"Routine2" clips:[[NSArray alloc] init]]; 
	}
	self.navigationController.navigationBar.tintColor = [UIColor 
														 blackColor]; 
}


- (void)viewWillAppear:(BOOL)animated {
	[self.tableView reloadData]; 
    [super viewWillAppear:animated];
}


/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	//return 2; 
    return [[Routine getRoutines] count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
	
	NSUInteger row = [indexPath row]; 
	Routine *rT = [[Routine getRoutines] objectAtIndex:row]; 
	cell.textLabel.text = [rT name]; 
	cell.detailTextLabel.text = nil; 	
    
	//should I release rT here? 
	
	return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	Routine *rt = [[Routine getRoutines] objectAtIndex:[indexPath row]]; 
	RoutineViewController *routineViewController = [[RoutineViewController alloc] initWithRoutine:rt];
	 [self.navigationController pushViewController:routineViewController animated:YES]; 
	[routineViewController release];
	//TestViewController *test = [[TestViewController alloc] initWithNibName:@"TestViewController" bundle:nil];
	//[self.navigationController pushViewController:test animated:YES]; 
	//[test release]; 
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
		[[Routine getRoutines] removeObjectAtIndex:[indexPath row]]; 
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}


// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
	NSUInteger fromPosition = [fromIndexPath row];
	NSUInteger toPosition = [toIndexPath row]; 
	NSMutableArray *allRoutines = [Routine getRoutines]; 
	Routine *rt = [allRoutines objectAtIndex:fromPosition];
	[allRoutines insertObject:rt atIndex:toPosition]; 
	if(toPosition < fromPosition) {
		fromPosition++; 
	}
	[allRoutines removeObjectAtIndex:fromPosition]; 
}


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
    [super dealloc];
}


@end

