//
//  Song.m
//  igroup
//
//  Created by Vidya on 3/31/10.
//  Copyright 2010 iGroup. All rights reserved.
//

#import "Song.h"


@implementation Song

@synthesize artistName, title, clips;
@synthesize songMediaItem;

static NSMutableDictionary *songs;

- (id) init { 
	if ( self = [super init] ) 
	{ 
		artistName = [[NSString alloc] init];
		title = [[NSString alloc] init]; 
		clips = [[NSMutableArray alloc] init]; 
		numClips = 0; 
	} 
	return self; 
}

+ (void)initialize {
    if (!songs) {
		songs = [[NSMutableDictionary alloc] init];
	}
}

/** Overrides songMediaItem's getter for lazy loading. */
- (MPMediaItem *)songMediaItem {
	if (songMediaItem) return songMediaItem;
	
	MPMediaQuery *query = [MPMediaQuery songsQuery];
	[query addFilterPredicate:[MPMediaPropertyPredicate predicateWithValue:title forProperty:MPMediaItemPropertyTitle]];
	NSArray *collections = [query collections];
	
	if ([collections count] == 1) {  // we've found exactly what we wants
		MPMediaItemCollection *collection = [collections objectAtIndex:0];
		songMediaItem = [[collection representativeItem] retain];
	} else {	// not found
		return nil;
	}
	
	return songMediaItem;
}

- (void)addClip:(Clip *)clip {
	numClips = numClips + 1; 
	[clips addObject:clip]; 
}

+ (Song *)getSong:(NSString *)title {
	Song *song = [songs objectForKey:title];
	if (!song) {
		song = [[Song alloc] init];
		song.title = title;
		[songs setObject:song forKey:title];
		[song release];
	}
	return song;
}

@end
