//
//  SongsViewController.m
//  igroup
//
//  Created by weicool on 3/30/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SongsViewController.h"
#import "ClipsViewController.h"
#import "PlayEditViewController.h" // remove later
#import "Song.h"
#import "Clip.h"
@class igroupAppDelegate;

//#import <MediaPlayer/MediaPlayer.h>

@implementation SongsViewController

@synthesize songsCollection, mediaCollection, appDelegate;

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

- (void)importLibrary {
	MPMediaQuery *query = [[MPMediaQuery alloc] init];
	
	// Can set whether we want to search by a particular artist or what have you.
	[query addFilterPredicate:[MPMediaPropertyPredicate predicateWithValue:@"Pop" forProperty:MPMediaItemPropertyGenre]];
	
	// Sets the grouping type for the media query
	[query setGroupingType: MPMediaGroupingTitle];
	
	self.mediaCollection = [query collections];
}

- (void) mediaPicker: (MPMediaPickerController *) mediaPicker didPickMediaItems: (MPMediaItemCollection *) collection {
    [self dismissModalViewControllerAnimated:YES];	
}

- (void)mediaPickerDidCancel:(MPMediaPickerController *)mediaPicker {
    [self dismissModalViewControllerAnimated: YES];
}

- (void)viewDidLoad {
    [super viewDidLoad];
	self.appDelegate = (igroupAppDelegate *) [[UIApplication sharedApplication] delegate];
	
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
	self.songsCollection = [[NSMutableArray alloc] init];
	[songsCollection release];
	
	if (self.appDelegate.debugMode) {
		[songsCollection addObject:@"Play/Edit Interface"]; 
		[songsCollection addObject:@"Poker Face"];
	} else {
		[self importLibrary];
	}
	
	self.navigationController.navigationBar.tintColor = [UIColor blackColor]; 
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	self.title = @"Songs";
}

/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [mediaCollection count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
    
	MPMediaItem *song = [[mediaCollection objectAtIndex:indexPath.row] representativeItem];
	
	cell.textLabel.text = [song valueForProperty: MPMediaItemPropertyTitle]; 
	cell.detailTextLabel.text = [NSString stringWithFormat:@"%@ - %@", [song valueForProperty:MPMediaItemPropertyAlbumTitle], [song valueForProperty:MPMediaItemPropertyArtist]];
	
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	//TODO: Test code just to make sure it's creating the table views correctly, this should be loaded from the dictionaries in the final version
//	Song *newSong = [[Song alloc] init];
//	Clip *newClip = [[Clip alloc] initWithSong: newSong];
//	newSong.title = @"Tik Tok";
//	newClip.name = @"Touch My Junk";
//	newClip.start = 50;
//	newClip.end = 150;
//	[newSong.clips addObject:newClip];
//	// END TEST CODE
//	if (indexPath.row == 0) {
//		PlayEditViewController *pevController = [[PlayEditViewController alloc] initWithNibName:@"PlayEditViewController" bundle:nil];
//		pevController.clip = newClip;
//		[self presentModalViewController:pevController animated:YES];
//		[pevController release];
//	} else {	
//		ClipsViewController *clipsViewController = [[ClipsViewController alloc] initWithNibName:@"ClipsViewController" bundle:nil];
//		NSLog(@"%@, myClip: %@", newSong, [(Clip *) [newSong.clips objectAtIndex:0] name]);
//		clipsViewController.mySong = newSong;
//		[self.navigationController pushViewController:clipsViewController animated:YES];
//		[clipsViewController release];
//	}
	
	MPMediaItem *songMediaItem = [[mediaCollection objectAtIndex:indexPath.row] representativeItem];
	Song *song = [Song getSong:[songMediaItem valueForProperty: MPMediaItemPropertyTitle]];
	ClipsViewController *clipsViewController = [[ClipsViewController alloc] initWithNibName:@"ClipsViewController" bundle:nil];
	clipsViewController.mySong = song;
	[self.navigationController pushViewController:clipsViewController animated:YES];
	[clipsViewController release];
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
		[songsCollection removeObjectAtIndex:[indexPath row]]; 
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
	[mediaCollection release];
	[songsCollection release]; 
    [super dealloc];
}


@end

